CREATE FUNCTION [dbo].[ParseRangeToTable](@cStr varchar(max))
RETURNS @retTab table (Item int)
/* WITH ENCRYPTION */
AS BEGIN

declare @cTEMP table 
( 
 ID bigint identity (1,1) not null,	
 Item varchar(50) default '',
 Range_From int default 0,	
 Range_To int default 0,
 flgRange tinyint default 0
)

declare @cXML XML;
set @cXML=cast('<a>'+
		REPLACE(@cStr, ',' ,'</a><a>')+'</a>' 
		as XML);

insert into @cTEMP(Item)
SELECT nref.value('.','varchar(50)') as Item
from @cXML.nodes('/a') AS R(nref)

update @cTEMP
set 
	flgRange=1,
	Range_From=pom.Range_From,
	Range_To=pom.Range_To
from(
	select Id as TempID, substring(Item,1,CHARINDEX('-', Item)-1) as Range_From,
			  substring(Item,CHARINDEX('-', Item)+1, len(Item)-(CHARINDEX('-', Item))) as Range_To	
	from @cTEMP
	where Item like '%-%'
) as pom
where ID = pom.TempID

insert into @cTEMP(Item)
select p1.Digit+10*p2.Digit+100*p3.Digit
from @cTEMP t
inner join (select cast(0 as int) as Digit
			union select 1 union select 2
			union select 3 union select 4
			union select 5 union select 6
			union select 7 union select 8
			union select 9) as p1 on (1=1)
inner join (select cast(0 as int) as Digit
			union select 1 union select 2
			union select 3 union select 4
			union select 5 union select 6
			union select 7 union select 8
			union select 9) as p2 on (1=1)
inner join (select cast(0 as int) as Digit
			union select 1 union select 2
			union select 3 union select 4
			union select 5 union select 6
			union select 7 union select 8
			union select 9) as p3 on (1=1)
where t.flgRange=1 and (
	t.Range_From<=(p1.Digit+10*p2.Digit+100*p3.Digit)and
	t.Range_To>=(p1.Digit+10*p2.Digit+100*p3.Digit)
)
order by t.Item,p1.Digit+10*p2.Digit+100*p3.Digit

delete from @cTEMP where flgRange=1;

insert into @retTab
select distinct Item from @cTEMP order by Item

RETURN
END
GO

select * from [dbo].[ParseRangeToTable]('1,32,4,11-16,19-21')
